package es.ehu.master2012;

import java.io.File;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.SQLException;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author Mikel & GBordel
 */
public class CompanyDB {
 	private String ticker;
	private Stock[] historic;
	
	private CompanyDB(){}
	
	public static CompanyDB newInstance(String ticker) throws IOException, SQLException{
            CompanyDB c=new CompanyDB();
            c.ticker = ticker;
            ResultSet rs=DBase.execSQL("SELECT * FROM Stock WHERE ticker='"+ticker+"'");
            rs.last();
            if (rs.getRow()!=0) 
            {
                c.historic=new Stock[rs.getRow()];
                for (int r=0;r<c.historic.length;r++){
                    rs.absolute(r+1);
                    c.historic[r]=
                        new Stock(rs.getString("date"),
                            rs.getFloat("open"),
                            rs.getFloat("max"),
                            rs.getFloat("min"),
                            rs.getFloat("close"),
                            rs.getInt("vol")
                            );
                }
                return c;
            }
            c.historic = Util.getStocks("http://charting.nasdaq.com/ext/charts.dll?2-1-14-0-0-5" + 
                                     "1" +
                                     "-03NA000000" +
                                     ticker +
                                     "-&SF:6|5-WD=530-HT=395--XTBL-");
             DBase.updateSQL("INSERT INTO Company (ticker, name, description) VALUES ('"+ticker+"','"+ticker+"','no description');");
             for (Stock s:c.historic) {
                 StringBuffer sb=new StringBuffer("INSERT INTO Stock (ticker, date ,open, max, min, close, vol ) VALUES ");
                 sb.append("('").append(ticker).append("','");
                 sb.append(s.getDate()).append("','");
                 sb.append(s.getOpen()).append("','");
                 sb.append(s.getMax()).append("','");
                 sb.append(s.getMin()).append("','");
                 sb.append(s.getClose()).append("','");
                 sb.append(s.getVol()).append("');");
                 DBase.updateSQL(sb.toString());
                 }    
             return c;
	}
        
        
	public String toXML(){
		StringBuilder sb = new StringBuilder();
		sb.append("<Company ticker=\"").append(ticker).append("\">\n");
		for (Stock s : historic) sb.append(s.toXML()).append('\n');
		sb.append("</Company>");
		return sb.toString();
	}
	
        
        public static CompanyDB newInstance(File file) throws ParserConfigurationException, SAXException, IOException {
		CompanyDB c = new CompanyDB();
		Document doc = DocumentBuilderFactory.newInstance().newDocumentBuilder().parse(file);
		Element root = doc.getDocumentElement();
		c.ticker = root.getAttribute("ticker");
                //if (companies.keySet().contains(c.ticker)) return companies.get(c.ticker); 
		NodeList list = root.getElementsByTagName("Stock");
		c.historic = new Stock[list.getLength()];
		for (int i = 0 ; i < list.getLength(); i++) {
			Element e = (Element) list.item(i);
			c.historic[i] = new Stock(
					e.getAttribute("Date"),
					Float.parseFloat(e.getAttribute("Open")),
					Float.parseFloat(e.getAttribute("Max")),
					Float.parseFloat(e.getAttribute("Min")),
					Float.parseFloat(e.getAttribute("Close")),
					Integer.parseInt(e.getAttribute("Vol"))
			);
		}
		return c;
	}

    public Stock[] getHistoric() {
        return historic;
    }
      
}
